
# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import glob
import re
import msilib
import waptlicences




def update_package():
    # Declaring local variables
    package_updated = False
    
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()

    dict_arch = {
        "x64" :"-64bit.msi",
        "x86"  :"-32bit.msi"
    }
  
    url_base = "https://memprofiler.com/msi-download"
    response = requests.get(url_base,allow_redirects=True, proxies=proxies)
    # Extract the correct div using bs_find_all
    divs = bs_find_all(response.text, "blockquote", proxies=proxies)
    msi_file = None
    for div in divs:
        if msi_file:
            break
        links = div.find_all('a', href=True)
        for link in links:
            if link['href'].endswith('.msi') and dict_arch[control.architecture] in link['href']:
                href = link['href']
                msi_file = href
                download_url = msi_file
                latest_bin = msi_file.split('/')[-1]
                # Utilisation des expressions régulières pour extraire la version
                match = re.search(r'MemProfilerInstaller(\d+_\d+_\d+)-', latest_bin)
                if match:
                    version = match.group(1).replace('_', '.')
                    print(f"Version trouvée : {version}")
                break


    # Downloading latest binaries
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
        package_updated = True
    else:
        print("Binary is present: %s" % latest_bin)
    # Check signature bin
    expected_issuer = 'SciTech Software AB'
    sign_name = waptlicences.check_msi_signature(latest_bin)[0]
    if sign_name != expected_issuer:
        error('Bad issuer %s != %s ' % (sign_name,expected_issuer))

    # Deleting outdated binaries
    for f in glob.glob('*.msi'):
        if f != latest_bin:
            remove_file(f)

           
    version = get_version_from_binary(latest_bin)
    # Mettre à jour le package
    control.set_software_version(version)
    control.save_control_to_wapt()    
        

